<template>
  <rui-loading v-if="loading"
               relative
               centered
               text="Loading document..."
               class="-mtl" />
  <template v-else>
    <header class="-mbl">
      <h1 class="-mb0">{{ describedComponent }}</h1>

      <div v-if="doc.sourceFiles.length > 0" class="-text--small">
        <strong>Sources:</strong>
        <code v-for="file in doc.sourceFiles" :key="file">{{ file }}</code>
      </div>
    </header>

    <rui-alert v-if="doc.deprecated" variant="warning" centered>
      <p>This component is deprecated and will be removed in the next major.</p>
      <p v-if="doc.deprecated !== true">{{ doc.deprecated }}</p>
    </rui-alert>

    <p v-if="doc.html && !doc.vuejs" class="-text--helping -mbl">
      This component is <em>HTML only</em>: it has no VueJS counterpart. Check the examples for ideas on how to use it.
    </p>
    <template v-else>
      <rui-alert v-if="!doc.description" variant="warning" class="-mbl">No description provided.</rui-alert>

      <markdown-renderer v-else class="-mbl" document>{{ doc.description }}</markdown-renderer>
    </template>
    <rui-tabs class="-mbd">
      <rui-button :active="tab === 'api'" icon="code" :disabled="!doc.vuejs" @click="tab='api'">API</rui-button>
      <rui-button :active="tab === 'playground'" icon="playground" :disabled="!hasPlayground" @click="tab='playground'">Playground</rui-button>
      <rui-button :active="tab === 'vuejs'" icon="file-vuejs" :disabled="!hasVueExamples" @click="tab='vuejs'">VueJS Examples</rui-button>
      <rui-button :active="tab === 'html'" icon="file-html" :disabled="!hasHtmlExamples" @click="tab='html'">HTML Examples</rui-button>
    </rui-tabs>

    <div v-show="tab==='api'">
      <component-api :name="describedComponent" />
    </div>
    <div v-if="hasPlayground" v-show="tab==='playground'">
      <component-playground :component-name="$route.params.page" />
    </div>
    <div v-if="hasVueExamples" v-show="tab==='vuejs'">
      <component-examples :name="describedComponent" file-type="vue" />
    </div>
    <div v-if="hasHtmlExamples" v-show="tab==='html'">
      <component-examples :name="describedComponent" file-type="html" />
    </div>
  </template>
</template>
<script>

import ComponentApi from '../components/ComponentApi.vue'
import ComponentExamples from '../components/ComponentExamples.vue'
import ComponentPlayground from '../components/ComponentPlayground.vue'
import MarkdownRenderer from '../components/MarkdownRenderer.vue'

export default {
  name: 'DocumentationView',
  components: { MarkdownRenderer, ComponentPlayground, ComponentApi, ComponentExamples },
  data () {
    return {
      loading: false,
      describedComponent: null,
      doc: null,
      tab: null,
    }
  },
  computed: {
    hasVueExamples () { return this.doc.examples.vue.length > 0 },
    hasHtmlExamples () { return this.doc.examples.html.length > 0 },
    hasPlayground () { return this.doc.playground.enabled },
  },
  methods: {
    initialize () {
      // Force update
      this.loading = true
      const describedComponent = this.$route.params.page
      const doc = this.$getDoc(describedComponent)

      this.describedComponent = describedComponent
      this.doc = doc
      this.tab = doc.vuejs ? 'api' : 'html'
      this.$setTitle(`Component: ${describedComponent}`)

      setTimeout(() => { this.loading = false }, 100)
    },
  },
  created () {
    this.initialize()
  },
  watch: {
    $route (newValue, oldValue) {
      // Ignore navigation to another route
      if (newValue.name !== oldValue.name) return

      this.initialize()
    },
    hasExamples (newValue) {
      if (newValue) return

      this.tab = 'api'
    },
  },
}
</script>
